import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core/ES5/type";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { IFastItemColumn$1 } from "igniteui-react-core/ES5/IFastItemColumn$1";
import { TrendLineType } from "igniteui-react-core/ES5/TrendLineType";
import { Brush } from "igniteui-react-core/ES5/Brush";
import { PenLineCap } from "igniteui-react-core/ES5/PenLineCap";
import { DoubleCollection } from "igniteui-react-core/ES5/DoubleCollection";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core/ES5/FastItemsSourceEventAction";
import { PointCollection } from "igniteui-react-core/ES5/PointCollection";
import { Clipper } from "igniteui-react-core/ES5/Clipper";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "igniteui-react-core/ES5/RenderingContext";
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    private or;
    readonly os: IAnchoredCategorySeriesInteractionManager;
    on: AnchoredCategorySeriesView;
    protected bf(): SeriesView;
    ii(a: SeriesView): void;
    ov: boolean;
    constructor();
    o2: string;
    valueColumn: IFastItemColumn$1<number>;
    private ot;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    pk: Brush;
    static readonly o9: DependencyProperty;
    trendLineThickness: number;
    pm: PenLineCap;
    pl: DoubleCollection;
    trendLinePeriod: number;
    ox: number;
    c6(a: any): boolean;
    protected ok(a: number, b: number, c: Axis): any[];
    protected io(a: any, b: string, c: any, d: any): void;
    an(a: Axis): AxisRange;
    protected ho(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected nu(): number;
    ow(a: CategorySeriesView): number;
    o7(a: PointCollection, b: number, c: CategorySeriesView): void;
    ol(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    om(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    hl(a: boolean, b: SeriesView): void;
    n8(a: CategoryFrame, b: CategorySeriesView): void;
    ob(a: CategoryFrame, b: CategorySeriesView): void;
    oo: CategoryFrame;
    i0(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    o4(a: CategoryFrame, b: CategorySeriesView): void;
    protected jc(): void;
    fm(a: any, b: Point): any;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly trendlinePreparer: IPreparesCategoryTrendline;
    protected oy: string;
    abstract o5(a: Axis): void;
    abstract o6(a: Axis): void;
    protected hu(a: any): void;
    op: CategorySeriesMarkerCollisionAvoidance;
    fj(a: Point): any;
    oq: ConsolidatedItemHitTestBehavior;
    readonly mayContainUnknowns: boolean;
    ec(): number;
    ao(): AxisRange;
    private o8();
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    cu: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private cv;
    cw: ITrendLineManager;
    readonly cx: boolean;
    c1(): void;
    cz(): void;
    cy(): void;
    cm(): CategoryBucketCalculator;
    c0(): void;
    c2(): void;
    c3(a: number): Rect;
    protected a2(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
    static $t: Type;
}
